/**
 *
 * Created by Kyle Benk kjbenk@gmail.com
 *
 * 12/14
 */

jQuery(document).ready(function($) {

	// Load stats via AJAX

	$.post(ajaxurl, {
			'action': 'wps_pf_stats_load',
			'ab_action': getQuerystring('action'),
			'start_date' : getQuerystring(wps_pf_stats_data.prefix_dash + 'start-date'),
			'end_date' : getQuerystring(wps_pf_stats_data.prefix_dash + 'end-date'),
			'popup_name' : getQuerystring('popup_name'),
			'popup_id' : getQuerystring('popup_id', false),
			'ab_popup_name' : getQuerystring('ab_popup_name'),
			'ab_popup_id' : getQuerystring('ab_popup_id', false)}, function(response) {

		response = jQuery.parseJSON(response);

		$("#" + wps_pf_stats_data.prefix_dash + "loading-stats").remove();
		$(response.stats_content).insertAfter("#" + wps_pf_stats_data.prefix_dash + "before-table");

		if ($("#" + wps_pf_stats_data.prefix_dash + "line-graph").length != 0) {

			if (getQuerystring('action', false) == 'ab-testing') {

				var popup_stats = response.stats.popup_stats;
				var ab_popup_stats = response.stats.ab_popup_stats;

				var dates = [];
				var popups = [];
				var impressions = [];
				var clicks = [];

				$.each(popup_stats, function(key, value){
					$.each(value, function(key_1, value_1){

						if (key_1 == 'popup_name') {
							popups.push(value_1);
						}

						if (key_1 == 'date') {
							dates.push(value_1);
						}

						if (key_1 == 'impressions') {
							impressions.push(value_1);
						}

						if (key_1 == 'clicks') {
							clicks.push(value_1);
						}
					});
				});


				if (getQuerystring('popup_name') != '') {
					var labels = dates;
				} else {
					var labels = popups;
				}


				// Line Graph

				var lineChartData = {
					labels : labels,
					datasets : [
						{
							label: "Impressions",
							fillColor : "rgba(220, 181, 69, 0.2)",
							strokeColor : "rgba(220, 181, 69, 1)",
							pointColor : "rgba(220, 181, 69, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(220, 181, 69, 1)",
							data : impressions
						},
						{
							label: "Clicks",
							fillColor : "rgba(81, 66, 205, 0.2)",
							strokeColor : "rgba(81, 66, 205, 1)",
							pointColor : "rgba(81, 66, 205, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(81, 66, 205, 1)",
							data : clicks
						}
					]

				}

				// Show No stats

				if (impressions.length == 0) {

					var lineChartData = {
						labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
						datasets : [
							{
								label: "Impressions",
								fillColor : "rgba(220, 181, 69, 0.2)",
								strokeColor : "rgba(220, 181, 69, 1)",
								pointColor : "rgba(220, 181, 69, 1)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : "rgba(220, 181, 69, 1)",
								data : ['25','45','43','18','26','34','21','20','29']
							},
							{
								label: "Clicks",
								fillColor : "rgba(81, 66, 205, 0.2)",
								strokeColor : "rgba(81, 66, 205, 1)",
								pointColor : "rgba(81, 66, 205, 1)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : "rgba(81, 66, 205, 1)",
								data : ['12','3','8','6','11','6','3','5','7']
							}
						]

					}

					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
					$('#wps-pf-line-graph').css('opacity', '0.5');
					$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#wps-pf-line-graph');
				}

				// Show Line graph if there are multiple stats

				else if (impressions.length > 1 && getQuerystring('popup_name') != '') {
					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
				}

				// Show Bar graph if there is only one day of stats  or on all Popup stats page

				else {
					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Bar(lineChartData, {
						responsive: true,
					});
				}

				var dates = [];
				var popups = [];
				var impressions = [];
				var clicks = [];

				$.each(ab_popup_stats, function(key, value){
					$.each(value, function(key_1, value_1){

						if (key_1 == 'popup_name') {
							popups.push(value_1);
						}

						if (key_1 == 'date') {
							dates.push(value_1);
						}

						if (key_1 == 'impressions') {
							impressions.push(value_1);
						}

						if (key_1 == 'clicks') {
							clicks.push(value_1);
						}
					});
				});

				if (getQuerystring('popup_name') != '') {
					var labels = dates;
				} else {
					var labels = popups;
				}

				// Line Graph

				var lineChartData = {
					labels : labels,
					datasets : [
						{
							label: "Impressions",
							fillColor : "rgba(220, 181, 69, 0.2)",
							strokeColor : "rgba(220, 181, 69, 1)",
							pointColor : "rgba(220, 181, 69, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(220, 181, 69, 1)",
							data : impressions
						},
						{
							label: "Clicks",
							fillColor : "rgba(81, 66, 205, 0.2)",
							strokeColor : "rgba(81, 66, 205, 1)",
							pointColor : "rgba(81, 66, 205, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(81, 66, 205, 1)",
							data : clicks
						}
					]

				}

				// Show No stats

				if (impressions.length == 0) {

					var lineChartData = {
						labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
						datasets : [
							{
								label: "Impressions",
								fillColor : "rgba(220, 181, 69, 0.2)",
								strokeColor : "rgba(220, 181, 69, 1)",
								pointColor : "rgba(220, 181, 69, 1)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : "rgba(220, 181, 69, 1)",
								data : ['25','45','43','18','26','34','21','20','29']
							},
							{
								label: "Clicks",
								fillColor : "rgba(81, 66, 205, 0.2)",
								strokeColor : "rgba(81, 66, 205, 1)",
								pointColor : "rgba(81, 66, 205, 1)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : "rgba(81, 66, 205, 1)",
								data : ['12','3','8','6','11','6','3','5','7']
							}
						]

					}

					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph-ab").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
					$('#wps-pf-line-graph-ab').css('opacity', '0.5');
					$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#wps-pf-line-graph-ab');
				}

				// Show Line graph if there are multiple stats

				else if (impressions.length > 1 && getQuerystring('popup_name') != '') {
					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph-ab").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
				}

				// Show Bar graph if there is only one day of stats  or on all Firebar stats page

				else {
					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph-ab").getContext("2d");
					window.myLine = new Chart(ctx).Bar(lineChartData, {
						responsive: true,
					});
				}

			} else {

				var dates = [];
				var popups = [];
				var impressions = [];
				var clicks = [];

				$.each(response.popup_stats, function(key, value){
					$.each(value, function(key_1, value_1){

						if (key_1 == 'popup_name') {

							//if (value_1.length >= max_name_length) {
								//popups.push(value_1.substring(0, max_name_length) + '...');
							//} else {
								popups.push(value_1);
							//}
						}

						if (key_1 == 'date') {
							dates.push(value_1);
						}

						if (key_1 == 'impressions') {
							impressions.push(value_1);
						}

						if (key_1 == 'clicks') {
							clicks.push(value_1);
						}
					});
				});


				if (getQuerystring('popup_name') != '') {
					var labels = dates;
				} else {
					var labels = popups;
				}


				// Line Graph

				var lineChartData = {
					labels : labels,
					datasets : [
						{
							label: "Impressions",
							fillColor : "rgba(220, 181, 69, 0.2)",
							strokeColor : "rgba(220, 181, 69, 1)",
							pointColor : "rgba(220, 181, 69, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(220, 181, 69, 1)",
							data : impressions
						},
						{
							label: "Clicks",
							fillColor : "rgba(81, 66, 205, 0.2)",
							strokeColor : "rgba(81, 66, 205, 1)",
							pointColor : "rgba(81, 66, 205, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(81, 66, 205, 1)",
							data : clicks
						}
					]

				}

				// Show No stats

				if (impressions.length == 0) {

					var lineChartData = {
						labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
						datasets : [
							{
								label: "Impressions",
								fillColor : "rgba(220, 181, 69, 0.2)",
								strokeColor : "rgba(220, 181, 69, 1)",
								pointColor : "rgba(220, 181, 69, 1)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : "rgba(220, 181, 69, 1)",
								data : ['25','45','43','18','26','34','21','20','29']
							},
							{
								label: "Clicks",
								fillColor : "rgba(81, 66, 205, 0.2)",
								strokeColor : "rgba(81, 66, 205, 1)",
								pointColor : "rgba(81, 66, 205, 1)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : "rgba(81, 66, 205, 1)",
								data : ['12','3','8','6','11','6','3','5','7']
							}
						]

					}

					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
					$('#' + wps_pf_stats_data.prefix_dash + 'line-graph').css('opacity', '0.5');
					$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#wps-pf-line-graph');
				}

				// Show Line graph if there are multiple stats

				else if (impressions.length > 1 && getQuerystring('popup_name') != '') {
					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
				}

				// Show Bar graph if there is only one day of stats  or on all Firebar stats page

				else {
					var ctx = document.getElementById(wps_pf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Bar(lineChartData, {
						responsive: true,
					});
				}
			}
		}
	});

	// Save weekly email settings

	$('input[name="' + wps_pf_stats_data.prefix_dash + 'send-weekly-email"]').change(function(){

		$.post(ajaxurl, {
			'action': 'wps_pf_send_weekly_email',
			'send_weekly_email': $('input[name="' + wps_pf_stats_data.prefix_dash + 'send-weekly-email"]').prop('checked')}, function(response) {

			response = jQuery.parseJSON(response);

		});
	});

	// Date Pickers

	if ($('#' + wps_pf_stats_data.prefix_dash + 'start-datepicker').length != 0 &&
		$('#' + wps_pf_stats_data.prefix_dash + 'end-datepicker').length != 0) {

		$('#' + wps_pf_stats_data.prefix_dash + 'start-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + wps_pf_stats_data.prefix_dash + 'end-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + wps_pf_stats_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(wps_pf_stats_data.today, "M/D/Y") );

		$('#' + wps_pf_stats_data.prefix_dash + 'start-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(wps_pf_stats_data.today, "M/D/Y") );

		$('#' + wps_pf_stats_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.minDate( $('#' + wps_pf_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

		$('#' + wps_pf_stats_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
	       $('#' + wps_pf_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
	    });

	    $('#' + wps_pf_stats_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
	       $('#' + wps_pf_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
	    });
	}

    /**
     * Gets a query parameter
     *
     * @access public
     * @param mixed key
     * @param mixed default_
     * @return void
     */
    function getQuerystring(key, default_) {
	  if (default_==null) default_="";
	  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	  var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
	  var qs = regex.exec(window.location.href);
	  if(qs == null)
	    return default_;
	  else
	    return qs[1];
	}
});