<?php
	//if uninstall not called from WordPress exit
	if ( !defined( 'WP_UNINSTALL_PLUGIN' ) )
		exit ();

	// Clear hook

	wp_clear_scheduled_hook('initialize_popup_stats_daily_cron');
	wp_clear_scheduled_hook('setup_popup_email_stats_cron');
	wp_clear_scheduled_hook('purge_popup_transients_cron');

	// Delete all existence of this plugin

	global $wpdb;

	include_once(dirname(__FILE__) . "/wpsite-popups.php");
	include_once(dirname(__FILE__) . "/admin/model/db.php");
	include_once(dirname(__FILE__) . "/core/model/stats.php");
	include_once(dirname(__FILE__) . "/core/model/email-signups.php");

	$version_option_name = 'wpsite_popup_version';
	$license_key_name = 'wpsite_popup_license_key';

	if ( !is_multisite() ) {
		$wpdb->query('DROP TABLE `' . WPsite_Popup_DB::getTableName() . '`');
		$wpdb->query('DROP TABLE `' . WPsite_Stats_PF::getTableName() . '`');
		$wpdb->query('DROP TABLE ' . WPsite_Email_Signups_PF::getTableName());

		// Delete all transient data

		$query = $wpdb->query($wpdb->prepare( "DELETE FROM {$wpdb->options} WHERE option_name LIKE %s", '%' . $wpdb->esc_like('_wpsite_popup_dismiss') . '%'));

		delete_option($version_option_name);
		delete_option($license_key_name);
	} else {
	    $blog_ids = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs" );
	    $original_blog_id = get_current_blog_id();

	    foreach ( $blog_ids as $blog_id ) {
	        switch_to_blog( $blog_id );
	        $wpdb->query('DROP TABLE `' . WPsite_Popup_DB::getTableName() . '`');
	        $wpdb->query('DROP TABLE `' . WPsite_Stats_PF::getTableName() . '`');
			$wpdb->query('DROP TABLE ' . WPsite_Email_Signups_PF::getTableName());

			// Delete all transient data

			$query = $wpdb->query($wpdb->prepare( "DELETE FROM {$wpdb->options} WHERE option_name LIKE %s", '%' . $wpdb->esc_like('_wpsite_popup_dismiss') . '%'));

	    }

	    restore_current_blog();

	    delete_site_option($version_option_name);
	    delete_site_option($license_key_name);
	}

?>